#include <cstdio>
#include <iostream>
#include <vector>
#include <cstdlib>
#include <cassert>
#include <ctime>
using namespace std;
#define NAME "parade"

const int N = 10000000;

bool p[N + 10];
vector <int> primes;

int main() {
    freopen(NAME".in", "r", stdin);
    freopen(NAME".out", "w", stdout);
    int k, n;
    cin >> k >> n;
    for (int i = 2; i * i <= N; ++i)
        if (!p[i])
            for (int j = i * i; j <= N; j += i)
                p[j] = true;
    for (int i = 2; i <= N; ++i)
        if (!p[i])
            primes.push_back(i);
    if (primes.size() < k || k > n * n)
        cout << -1 << endl;
    else {
		int i = 0;
		while (i < k) {
			printf("%d ", primes[i]);
			++i;
			if (i % n == 0) printf("\n");
		}
		
		while (i < n * n) {
			printf("%d ", primes[0]);
			++i;
			if (i % n == 0) printf("\n");
		}
	}
    return 0;
}
